routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\Admin\DashboardController;
use App\Http\Controllers\Admin\UserController;
use App\Http\Controllers\Admin\DepartmentController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function(){
	return redirect('login');
});

Route::get('/logout', function(){
	Auth::logout();
    return redirect('/login');
});

Route::group(['middleware' => ['auth']], function() {
    //dashboard
    Route::get('admin/dashboard', [DashboardController::class, 'index'])->name('admin.dashboard');
    //user
    Route::resource('admin/users', UserController::class);
    Route::post('admin/users/getUsers', [UserController::class,'getUsers'])->name('admin.users.getUsers');
    //department
    Route::resource('admin/departments', DepartmentController::class);
    Route::post('admin/users/getDepartments', [DepartmentController::class,'getDepartments'])->name('admin.users.getDepartments');
});
Auth::routes();

app/Models/Department.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Department extends Model
{
    use HasFactory;


    protected $fillable = [
        'name',
        'description',
    ];
}

app/Http/Controllers/Admin/DepartmentController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Models\Department;
use Validator;
use Auth;
use DataTables;
use Config;
use Form;
use DB;

class DepartmentController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('admin/departments/index'); 
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.departments.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        try{
      
        $validator = Validator::make($request->all(), [
            'name'       => 'required', 
            'description'  => 'required', 
        ]);     

        if ($validator->fails()) {
            return redirect()->back()
                        ->withErrors($validator)
                        ->withInput();
        }


      
            $data = $request->all();
            $user = Department::create($data);
            $request->session()->flash('success','Department added Successfully');
            return redirect()->to('admin/departments');
         

        }catch (\Exception $e){
            return redirect()->back()->with('error',$e->getMessage());
        }

    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        try{
            $department = Department::findOrFail($id);
            return view('admin.departments.create',compact('department'));
        }catch (\Exception $e){
            return redirect()->back()->with('error',$e->getMessage());
        }
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        try{

            $validator = Validator::make($request->all(), [
                'name'       => 'required|unique:departments,name,'.$id, 
                'description'        => 'required', 
            ]);     
    
            if ($validator->fails()) {
                return redirect()->back()
                            ->withErrors($validator)
                            ->withInput();
            }
    
    
                $department = Department::findOrFail($id);
                $data = $request->all();
                $department->update($data);
                $request->session()->flash('success','department updated Successfully');
                return redirect()->to('admin/departments');
    
            }catch (\Exception $e){
                return redirect()->back()->with('error',$e->getMessage());
            }
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        try{ 
            $department = Department::findOrFail($id);
            $department->delete();
            session()->flash('danger','Department deleted successfully');
            return redirect()->to('admin/departments');
        }catch (\Exception $e){
            return redirect()->back()->with('error',$e->getMessage());
        }
    }

    public function getDepartments(Request $request){
        $department = Department::select([\DB::raw(with(new Department)->getTable().'.*')]);
      return DataTables::of($department)
          ->editColumn('created_at', function($department){
              return date('Y-m-d', strtotime($department->created_at));
          })            
          ->editColumn('name', function($department){
              return $department->name;
          })
          ->editColumn('description', function($department){
            return $department->description;
        })
         
          ->addColumn('action', function ($department) {
              return
                  // edit
                  '<a href="'.route('departments.edit',[$department->id]).'" class="btn btn-success btn-circle btn-sm"><i class="fas fa-edit"></i></a> '.
                  // Delete
                    Form::open(array(
                                'style' => 'display: inline-block;',
                                'method' => 'DELETE',
                                'onsubmit'=>"return confirm('Do you really want to delete?')",
                                'route' => ['departments.destroy', $department->id])).
                    ' <button type="submit" class="btn btn-danger btn-circle btn-sm"><i class="fas fa-trash"></i></button>'.
                    Form::close();
          })
          ->rawColumns(['action'])
          ->make(true);
  }
}

resources/views/admin/departments/create.blade.php
@extends('admin.layouts.valex_app')
@section('styles')
@endsection
@section('content')
<div class="container">
    <div class="breadcrumb-header justify-content-between">
      <div class="left-content">
          <div>
            <h2 class="main-content-title tx-24 mg-b-1 mg-b-lg-1">Department</h2>
          </div>
      </div>
    </div>
    <div class="row row-sm">
        <div class="col-xl-12">
            <div class="card">
            {!! Form::open(['method' => 'POST','url' => isset($department->id)?route('departments.update',[$department->id]):route('departments.store'),'class' => 'form-horizontal','id' => 'frmDepartment']) !!}
                @csrf
                @if(isset($department->id))
                @method('PUT')
                @endif
                <div class="card-header py-3 cstm_hdr">
                    <h6 class="m-0 font-weight-bold text-primary">Add Department</h6>
                </div>
                <div class="card-body">
                    <div class="form-group @error('name') has-error @enderror">
                        <label class="col-md-3 control-label" for="name">Name <span style="color:red">*</span></label>
                         <div class="col-md-6">
                        {!! Form::text('name', old('name', isset($department->name)? $department->name :''), ['class' => 'form-control', 'placeholder' => 'Name']) !!}
                        @error('name')<small class="help-block">{{ $message }}</small> @enderror
                        </div>
                    </div>

                    <div class="form-group @error('description') has-error @enderror">
                        <label class="col-md-3 control-label" for="description">Description<span style="color:red">*</span></label>
                         <div class="col-md-6">
                            {!! Form::text('description', old('description', isset($department->description)? $department->description :''), ['class' => 'form-control', 'placeholder' => 'Description']) !!}
                            @error('description')<small class="help-block">{{ $message }}</small> @enderror
                        </div>
                    </div>

                <div class="card-footer">
                    <button type="submit" class="btn btn-responsive btn-primary">{{ __('Submit') }}</button>
                    <a href="{{url('admin/users')}}"  class="btn btn-responsive btn-secondary">{{ __('Cancel') }}</a>
                </div>
                {!! Form::close() !!}
            </div>
        </div>
    </div>        
</div>
<!-- /.container-fluid -->
@endsection
@section('scripts')
@endsection

resources/views/admin/departments/index.blade.php
@extends('admin.layouts.valex_app')
@section('styles')
<link href="{{asset('template/valex-theme/plugins/datatable/css/dataTables.bootstrap4.min.css')}}" rel="stylesheet" />
<link href="{{asset('template/valex-theme/plugins/datatable/css/responsive.bootstrap4.min.css')}}" rel="stylesheet" />
<link href="{{asset('template/valex-theme/plugins/datatable/css/buttons.bootstrap4.min.css')}}" rel="stylesheet">
<link href="{{asset('template/valex-theme/plugins/datatable/css/jquery.dataTables.min.css')}}" rel="stylesheet">
<link href="{{asset('template/valex-theme/plugins/datatable/css/responsive.dataTables.min.css')}}" rel="stylesheet">
@endsection
@section('content')
<!-- Begin Page Content -->
<div class="container">
  <div class="breadcrumb-header justify-content-between">
      <div class="left-content">
          <div>
            <h2 class="main-content-title tx-24 mg-b-1 mg-b-lg-1">Departments</h2>
          </div>
      </div>
  </div>
  <div class="row row-sm">
    <div class="col-xl-12">
      <div class="card">
        <div class="card-header py-3 cstm_hdr">
            <h6 class="m-0 font-weight-bold text-primary">Departments List</h6>
            <a href="{{route('departments.create')}}" class="btn btn-sm btn-icon-split float-right btn-outline-warning">
                <span class="icon text-white-50">
                  <i class="fas fa-plus"></i>
                </span>
                <span class="text">Add Department</span>
            </a>
        </div>
        <div class="card-body">
            <div class="table-responsive">
                <table class="table table-bordered" width="100%" cellspacing="0" id="departments">
                    <thead>
                        <tr>
                          <th>Department Name</th>
                          <th>Description</th>
                          <th>Action</th>                          
                        </tr>
                    </thead>
                    <tfoot>
                        <tr>
                         <th>Department Name</th>
                          <th>Description</th>
                          <th>Action</th>                       
                        </tr>
                    </tfoot>
                </table>
            </div>
        </div>
      </div>
    </div>
  </div>
</div>    
<!-- /.container-fluid -->
@endsection
@section('scripts')
<!-- Page level plugins -->
<script src="{{ asset('template/valex-theme/plugins/datatable/js/jquery.dataTables.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/dataTables.dataTables.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/dataTables.responsive.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/responsive.dataTables.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/jquery.dataTables.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/dataTables.bootstrap4.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/dataTables.responsive.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/responsive.bootstrap4.min.js') }}"></script>
<script src="{{ asset('template/valex-theme/plugins/datatable/js/vfs_fonts.js') }}"></script>
<!-- export btn -->
<script type="text/javascript">
jQuery(document).ready(function(){
    getDepartments();
});

function getDepartments(){
  jQuery('#departments').dataTable().fnDestroy();
  jQuery('#departments tbody').empty();
  jQuery('#departments').DataTable({
      processing: true,
      serverSide: true,
      iDisplayLength:50,
      ajax: {
          url: '{{ route('admin.users.getDepartments') }}',
          method: 'POST',  
      },
      lengthMenu: [
          [10, 25, 50, 100,1000, -1],
          [10, 25, 50,100,1000,"All"]
      ],
      columns: [
          {data: 'name', name: 'name'},
          {data: 'description', name: 'description'},
          {data: 'action', name: 'action', orderable: false, searchable: false, "width": "10%"},            
      ],           
      order: [[0, 'desc']],
      language: {
            searchPlaceholder: 'Search...',
            sSearch: '',
            lengthMenu: '_MENU_',
      },        
    });
}
</script>
@endsection